"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const jsxRuntime = require("react/jsx-runtime");
const store = require("./store.cjs");
const require$$0 = require("react");
const contextMap = /* @__PURE__ */ new WeakMap();
function getStoreScopeContext(scope) {
  let context = contextMap.get(scope);
  if (!context) {
    context = require$$0.createContext(store.store(scope.defaultValue));
    contextMap.set(scope, context);
  }
  return context;
}
function StoreScopeProvider({ scope, store: inputStore, children }) {
  const context = getStoreScopeContext(scope);
  const currentStore = require$$0.useMemo(() => inputStore ?? store.store(scope.defaultValue), [scope, inputStore]);
  return /* @__PURE__ */ jsxRuntime.jsx(context.Provider, { value: currentStore, children });
}
function useStoreScope(scope) {
  const context = getStoreScopeContext(scope);
  return require$$0.useContext(context);
}
var withSelectorExports = {};
var withSelector = {
  get exports() {
    return withSelectorExports;
  },
  set exports(v) {
    withSelectorExports = v;
  }
};
var useSyncExternalStoreWithSelector_production_min = {};
var hasRequiredUseSyncExternalStoreWithSelector_production_min;
function requireUseSyncExternalStoreWithSelector_production_min() {
  if (hasRequiredUseSyncExternalStoreWithSelector_production_min)
    return useSyncExternalStoreWithSelector_production_min;
  hasRequiredUseSyncExternalStoreWithSelector_production_min = 1;
  var g = require$$0;
  function n(a, b) {
    return a === b && (0 !== a || 1 / a === 1 / b) || a !== a && b !== b;
  }
  var p = "function" === typeof Object.is ? Object.is : n, q = g.useSyncExternalStore, r = g.useRef, t = g.useEffect, u = g.useMemo, v = g.useDebugValue;
  useSyncExternalStoreWithSelector_production_min.useSyncExternalStoreWithSelector = function(a, b, e, l, h) {
    var c = r(null);
    if (null === c.current) {
      var f = { hasValue: false, value: null };
      c.current = f;
    } else
      f = c.current;
    c = u(function() {
      function a2(a3) {
        if (!c2) {
          c2 = true;
          d2 = a3;
          a3 = l(a3);
          if (void 0 !== h && f.hasValue) {
            var b2 = f.value;
            if (h(b2, a3))
              return k = b2;
          }
          return k = a3;
        }
        b2 = k;
        if (p(d2, a3))
          return b2;
        var e2 = l(a3);
        if (void 0 !== h && h(b2, e2))
          return b2;
        d2 = a3;
        return k = e2;
      }
      var c2 = false, d2, k, m = void 0 === e ? null : e;
      return [function() {
        return a2(b());
      }, null === m ? void 0 : function() {
        return a2(m());
      }];
    }, [b, e, l, h]);
    var d = q(a, c[0], c[1]);
    t(function() {
      f.hasValue = true;
      f.value = d;
    }, [d]);
    v(d);
    return d;
  };
  return useSyncExternalStoreWithSelector_production_min;
}
var useSyncExternalStoreWithSelector_development = {};
var hasRequiredUseSyncExternalStoreWithSelector_development;
function requireUseSyncExternalStoreWithSelector_development() {
  if (hasRequiredUseSyncExternalStoreWithSelector_development)
    return useSyncExternalStoreWithSelector_development;
  hasRequiredUseSyncExternalStoreWithSelector_development = 1;
  if (process.env.NODE_ENV !== "production") {
    (function() {
      if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart === "function") {
        __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
      }
      var React = require$$0;
      function is(x, y) {
        return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y;
      }
      var objectIs = typeof Object.is === "function" ? Object.is : is;
      var useSyncExternalStore = React.useSyncExternalStore;
      var useRef = React.useRef, useEffect = React.useEffect, useMemo = React.useMemo, useDebugValue = React.useDebugValue;
      function useSyncExternalStoreWithSelector(subscribe, getSnapshot, getServerSnapshot, selector, isEqual) {
        var instRef = useRef(null);
        var inst;
        if (instRef.current === null) {
          inst = {
            hasValue: false,
            value: null
          };
          instRef.current = inst;
        } else {
          inst = instRef.current;
        }
        var _useMemo = useMemo(function() {
          var hasMemo = false;
          var memoizedSnapshot;
          var memoizedSelection;
          var memoizedSelector = function(nextSnapshot) {
            if (!hasMemo) {
              hasMemo = true;
              memoizedSnapshot = nextSnapshot;
              var _nextSelection = selector(nextSnapshot);
              if (isEqual !== void 0) {
                if (inst.hasValue) {
                  var currentSelection = inst.value;
                  if (isEqual(currentSelection, _nextSelection)) {
                    memoizedSelection = currentSelection;
                    return currentSelection;
                  }
                }
              }
              memoizedSelection = _nextSelection;
              return _nextSelection;
            }
            var prevSnapshot = memoizedSnapshot;
            var prevSelection = memoizedSelection;
            if (objectIs(prevSnapshot, nextSnapshot)) {
              return prevSelection;
            }
            var nextSelection = selector(nextSnapshot);
            if (isEqual !== void 0 && isEqual(prevSelection, nextSelection)) {
              return prevSelection;
            }
            memoizedSnapshot = nextSnapshot;
            memoizedSelection = nextSelection;
            return nextSelection;
          };
          var maybeGetServerSnapshot = getServerSnapshot === void 0 ? null : getServerSnapshot;
          var getSnapshotWithSelector = function() {
            return memoizedSelector(getSnapshot());
          };
          var getServerSnapshotWithSelector = maybeGetServerSnapshot === null ? void 0 : function() {
            return memoizedSelector(maybeGetServerSnapshot());
          };
          return [getSnapshotWithSelector, getServerSnapshotWithSelector];
        }, [getSnapshot, getServerSnapshot, selector, isEqual]), getSelection = _useMemo[0], getServerSelection = _useMemo[1];
        var value = useSyncExternalStore(subscribe, getSelection, getServerSelection);
        useEffect(function() {
          inst.hasValue = true;
          inst.value = value;
        }, [value]);
        useDebugValue(value);
        return value;
      }
      useSyncExternalStoreWithSelector_development.useSyncExternalStoreWithSelector = useSyncExternalStoreWithSelector;
      if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop === "function") {
        __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
      }
    })();
  }
  return useSyncExternalStoreWithSelector_development;
}
(function(module2) {
  if (process.env.NODE_ENV === "production") {
    module2.exports = requireUseSyncExternalStoreWithSelector_production_min();
  } else {
    module2.exports = requireUseSyncExternalStoreWithSelector_development();
  }
})(withSelector);
function useStore(store$1, options) {
  const lastEqualsRef = require$$0.useRef();
  const subOptions = { ...options, runNow: false, equals: void 0 };
  const subscribe = require$$0.useCallback(
    (listener) => {
      return store$1.sub(listener, subOptions);
    },
    [store$1, store.hash(subOptions)]
  );
  const value = withSelectorExports.useSyncExternalStoreWithSelector(
    subscribe,
    store$1.get,
    void 0,
    (x) => x,
    (options == null ? void 0 : options.equals) ?? ((_v, newValue) => {
      var _a;
      return ((_a = lastEqualsRef.current) == null ? void 0 : _a.call(lastEqualsRef, newValue)) ?? false;
    })
  );
  const [proxiedValue, equals] = store.trackingProxy(value);
  require$$0.useLayoutEffect(() => {
    lastEqualsRef.current = equals;
  });
  require$$0.useDebugValue(value);
  return proxiedValue;
}
function useProp(store2, options) {
  const value = useStore(store2, options);
  return [value, store2.update];
}
exports.StoreScopeProvider = StoreScopeProvider;
exports.useProp = useProp;
exports.useStore = useStore;
exports.useStoreScope = useStoreScope;
//# sourceMappingURL=react.cjs.map
